<?php

/**
 * @file
 * OpenID Selector for Drupal administration menu items.
 *
 */

function openid_selector_drupal_settings() {
  $form['#attributes'] = array('enctype' => "multipart/form-data");
  if ($file = file_save_upload('openid_selector_drupal_logo_upload', array('file_validate_is_image' => array(), 'file_validate_image_resolution' => array('100x60')))) {
    $parts = pathinfo($file->filename);
    $filename = 'openid_selector_drupal-logo.'. $parts['extension'];
    if (file_copy($file, $filename, FILE_EXISTS_REPLACE)) {
      $_POST['openid_selector_drupal_large_mode'] = 3;
      $_POST['openid_selector_drupal_logo'] = $file->filepath;
    }
  }
  if ($file = file_save_upload('openid_selector_drupal_favicon_upload', array('file_validate_is_image' => array(), 'file_validate_image_resolution' => array('16x16')))) {
    $parts = pathinfo($file->filename);
    $filename = 'openid_selector_drupal-favicon.'. $parts['extension'];
    if (file_copy($file, $filename, FILE_EXISTS_REPLACE)) {
      $_POST['openid_selector_drupal_small_mode'] = 1;
      $_POST['openid_selector_drupal_favicon'] = $file->filepath;
    }
  }
  $form['openid_selector_drupal_large'] = array(
    '#type' => 'fieldset',
    '#title' => t('Large button settings'),
  );
  $form['openid_selector_drupal_large']['openid_selector_drupal_large_mode'] = array(
    '#type' => 'radios',
    '#title' => t('Display mode'),
    '#options' => array(
      t('Site name'),
      t('Custom name'),
      t('Site logo'),
      t('Custom logo')
    ),
    '#description' => t('What to display on large button'),
    '#default_value' => variable_get('openid_selector_drupal_large_mode', 0),
  );
  $form['openid_selector_drupal_large']['openid_selector_drupal_site_name'] = array(
    '#type' => 'textfield',
    '#title' => t('Custom name'),
    '#description' => t('Use this in case default site name is too long and flows out the boundaries of large button'),
    '#default_value' => variable_get('openid_selector_drupal_site_name', ''),
  );
  $form['openid_selector_drupal_large']['openid_selector_drupal_logo'] = array(
    '#type' => 'textfield',
    '#title' => t('Custom logo'),
    '#description' => t('Path to custom logo. Must not exceed 100x60px'),
    '#default_value' => variable_get('openid_selector_drupal_logo', ''),
  );
  $form['openid_selector_drupal_large']['openid_selector_drupal_logo_upload'] = array(
    '#type' => 'file',
    '#title' => t('Upload custom logo'),
    '#maxlength' => 40,
    '#description' => t("If you don't have direct file access to the server, use this field to upload custom logo.")
  );
  $form['openid_selector_drupal_small'] = array(
    '#type' => 'fieldset',
    '#title' => t('Small button settings'),
  );
  $form['openid_selector_drupal_small']['openid_selector_drupal_small_mode'] = array(
    '#type' => 'radios',
    '#title' => t('Display mode'),
    '#options' => array(
      t('Site favicon'),
      t('Custom favicon'),
    ),
    '#description' => t('What to display on small button'),
    '#default_value' => variable_get('openid_selector_drupal_small_mode', 0),
  );
  $form['openid_selector_drupal_small']['openid_selector_drupal_favicon'] = array(
    '#type' => 'textfield',
    '#title' => t('Custom favicon'),
    '#description' => t('Path to custom favicon. Must not exceed 16x16px'),
    '#default_value' => variable_get('openid_selector_drupal_favicon', ''),
  );
  $form['openid_selector_drupal_small']['openid_selector_drupal_favicon_upload'] = array(
    '#type' => 'file',
    '#title' => t('Upload custom favicon'),
    '#maxlength' => 40,
    '#description' => t("If you don't have direct file access to the server, use this field to upload custom favicon.")
  );
  $form = system_settings_form($form);
  return $form;
}
